#include "componentFold.h"

componentFold::componentFold(int _id) : rectComponent(_id,OURFOLD)
{


}


void componentFold::startUp(MyRect boundingBox, MyRect texBoundingBox)
{
	vertices.push_back(Vertex(boundingBox.left, boundingBox.top, 0.0, LEFT_BORDER)); //top left
	vertices.push_back(Vertex(boundingBox.left, boundingBox.bottom, 0.0, LEFT_BORDER));	//bottom left
	vertices.push_back(Vertex((boundingBox.left+boundingBox.right)/2, boundingBox.top, 0.0, DISPLACED)); //top middle
	vertices.push_back(Vertex((boundingBox.left+boundingBox.right)/2, boundingBox.bottom, 0.0, DISPLACED));	//bottom middle
	vertices.push_back(Vertex(boundingBox.right, boundingBox.top, 0.0, RIGHT_BORDER)); //top right
	vertices.push_back(Vertex(boundingBox.right, boundingBox.bottom, 0.0, RIGHT_BORDER)); //bottom right

	myBoundingBox.left = boundingBox.left;
	myBoundingBox.top = boundingBox.top;
	myBoundingBox.right = boundingBox.right;
	myBoundingBox.bottom = boundingBox.bottom;

	myTextureBoundingBox.left = boundingBox.left;
	myTextureBoundingBox.top = boundingBox.top;
	myTextureBoundingBox.right = boundingBox.right;
	myTextureBoundingBox.bottom = boundingBox.bottom;

	updateTexCoords(myTextureBoundingBox);
}

bool componentFold::updateFoldDepth(double amount)
{
	//this component has exactly 6 vertices, have to update the middle two
	std::list<Vertex>::iterator it = vertices.begin();
	it++;
	it++;
	//change the z coordinate by amount into negative z direction
	if( _isnan(amount) ) //if we go into positive z direction, abort and return true
	{
		return true;
	}
	
	it->position[2] = - amount;
	
	it++;
	it->position[2] = - amount;

	return false;
}

double componentFold::getExplicitDepth()
{
	std::list<Vertex>::iterator it = vertices.begin();
	it++;
	it++;
	
	return - it->position[2];
}

void componentFold::setExplicitTexCoord(double left, double middle, double right)
{
	std::list<Vertex>::iterator it = vertices.begin();

	it->texCoord[0] = left;

	it++;

	it->texCoord[0] = left;

	it++;

	it->texCoord[0] = middle;

	it++;

	it->texCoord[0] = middle;

	it++;

	it->texCoord[0] = right;

	it++;

	it->texCoord[0] = right;
}