#ifndef _RECTCOMPONENT
#define _RECTCOMPONENT

#include "vertex.h"
#include <list>
#include <vector>

struct MyRect
{
	double left;
	double top;
	double right;
	double bottom;
};

enum MyCompType { OURPLANE, OURFOLD};

class rectComponent
{
public:
	rectComponent(int _id, MyCompType _type) : id(_id), type(_type) {}

	virtual void startUp(MyRect boundingBox, MyRect texBoundingBox) = 0;
	virtual void returnVerts() = 0;
	void updateTexCoords(MyRect newTextureBoundingBox);
	std::vector<std::vector<double>> getPositions();
	std::vector<double> getTexCoords();
	MyCompType getType() {return type;}
	void resize(MyRect newSizeBox, MyRect newTextureBoundingBox);

	MyRect getBoundingBox();
	MyRect getTextureBoundingBox();
	int getId() { return id; }
	virtual bool updateFoldDepth(double amount) = 0;		//returns true if this fold is into positive z direction (delete this fold and restore the original plane)

protected:
	MyRect myBoundingBox;
	MyRect myTextureBoundingBox;
	MyCompType type;
	int id;
	std::list<Vertex> vertices;
	
private:
	rectComponent() {}
};

#endif