#ifndef WINDOW_H
#define WINDOW_H

#include <QWidget>
#include <qpushbutton.h>
#include <iostream>
#include "config.h"
#include <QString>
#include <QLabel>
#include <qcheckbox.h>
#include <qlineedit.h>

using namespace std;

class GLWidget;

class Window : public QWidget
{
    Q_OBJECT

public:
    Window();

	
public slots:
	void openFile();
	void setSelectionBoxEnabled(int enabled);
	void setSelectedComponentLabelId(int id);
	void resetComponents();
	void changeStatus(QString message);
	void setNumberOfComponents(int count);
	void setComponentWidth(QString numberstring);

private:
    GLWidget *glWidget;
	QPushButton *openfilebutton;
	QLabel *openfilelabel;
	QCheckBox *optionselectionbox;
	QLabel *selectedcomponentlabel;
	QPushButton *resetbutton;
	QLabel *statuslabel;
	QLabel *componentnumberlabel;
	QLineEdit *configedit;
	QLabel *configeditlabel;
};

#endif
